### Constructor

# GUPnP RootDevice new_full

#### Declaration [src]

    GUPnPRootDevice*
    gupnp_root_device_new_full (
      GUPnPContext* context,
      GUPnPResourceFactory* factory,
      GUPnPXMLDoc* description_doc,
      const char* description_path,
      const char* description_folder,
      GError** error
    )

#### Description [src]

Create a new `GUPnPRootDevice`, automatically loading and parsing device description document from `description_path` if `description_doc` is `NULL`.

#### Parameters

`context` | `GUPnPContext`
| A `GUPnPContext`.
| The data is owned by the caller of the function.
`factory` | `GUPnPResourceFactory`
| A `GUPnPResourceFactory`.
| The data is owned by the caller of the function.
`description_doc` | `GUPnPXMLDoc`
| Device description document, or `NULL`.
| The data is owned by the caller of the function.
`description_path` | `const char*`
| Path to device description document. This could either be an absolute path or path relative to `description_dir`.
| The data is owned by the caller of the function.
| The value is a NUL terminated UTF-8 string.
`description_folder` | `const char*`
| Path to folder where description documents are provided.
| The data is owned by the caller of the function.
| The value is a NUL terminated UTF-8 string.
`error` | `GError **`
| The return location for a `GError*`, or `NULL`.

#### Return value

Returns: | `GUPnPRootDevice`
| A new `GUPnPRootDevice` object.
| The caller of the function takes ownership of the data, and is responsible for freeing it.